-- Scoring through writing something to chat

local words = {"sheep", "sonic", "tails", "eggman", "wario", "banana", "123456", "qwerty", "baguette", "knuckles", "tarlatata", "ball", "archibald", "haha"}

local wantword = nil

ww_afterfuncs["WW_CHAT"] = function()
	for player in players.iterate do
		if not (player.spectator or not player.ww_chatscore) then
			player.ww_chatscore = nil
			WW_AddPoints(player, 1)
		end
	end
	
	wantword = nil
end

WW_Event("WW_CHAT", function()
	WW_DoAfter("WW_CHAT", 4*TICRATE)
	
	for player in players.iterate do player.ww_chatscore = nil end
	
	wantword = words[P_RandomRange(1, #words)]
	
	WW_InstructionAll("TYPE "..wantword)
end)

addHook("PlayerMsg", function(p, _, _, msg)
	if not wantword then return end

	if msg:lower() == wantword:lower() then p.ww_chatscore = true end
end)

addHook("NetVars", function(net)
	wantword = net($)
end)