local MT_PLAYER = MT_PLAYER
local addHook = addHook

function A_CheckSpeed(actor, var1, var2)
    if FixedHypot(actor.momx, actor.momy) < var1 then actor.state = var2 end
end


---------Warp players to spawn, remove item, reset state, and start new game-------------
local function Warp00(line, mobj)	
	for player in players.iterate do
	S_ChangeMusic("DSPATW")
		if player.spectator then continue end
		P_SetOrigin(player.mo, 0*FRACUNIT, 0*FRACUNIT, 10*FRACUNIT)
		
		local item = player.mo.hnext
		local nextitem
		
		while item and item.valid do
			nextitem = item.hnext			
			P_RemoveMobj(item)			
			item = nextitem
		end		
		K_StripItems(player)
		
		// End game
	end
	P_LinedefExecute(999) // new game
end

-----------Rising platform game--------------
local function Warp01(line, mobj)	
	WW_InstructionAll("Stay on the raft!")
end

----------Player get 2 orbis,  Hit a player to win---------
local function Warp02(line, mobj)	
	for player in players.iterate do
		if player.spectator then continue end
		player.kartstuff[k_itemtype] = KITEM_ORBINAUT
		player.kartstuff[k_itemamount] = 2
	end
end

----------Player get 2 orbis,  Don't get hurt to win---------
local function Warp03(line, mobj)	
	for player in players.iterate do
		if player.spectator then continue end
		player.kartstuff[k_itemtype] = KITEM_ORBINAUT
		player.kartstuff[k_itemamount] = 1
		//set game that required Surviving
	end
end

----------Player get 1 mine, Hit a player to win---------
local function Warp04(line, mobj)	
	for player in players.iterate do
		if player.spectator then continue end
		player.kartstuff[k_itemtype] = KITEM_MINE
		player.kartstuff[k_itemamount] = 1
		//set game that required Hitting player
	end
end

----------mini race 1---------
local function Warp05(line, mobj)	
WW_InstructionAll("RACE!")
	for player in players.iterate do
		if player.spectator then continue end
		player.kartstuff[k_itemtype] = KITEM_SNEAKER
		player.kartstuff[k_itemamount] = 1
	end
end

----------mini race 2---------
local function Warp06(line, mobj)	
WW_InstructionAll("RACE!")
	for player in players.iterate do
		if player.spectator then continue end
		player.kartstuff[k_itemtype] = KITEM_SNEAKER
		player.kartstuff[k_itemamount] = 1
	end
end

----------Don't move---------
local function Warp07(line, mobj)	
	// Check after 3s if player has 0 velocity
	// If 0 , give point
	//else Nothing, or explose them idk
end

----------Move fast---------
local function Warp08(line, mobj)	
	// Check after 4s if player has X velocity
	// If speed>X , give point
	// else  nothing or explose them idk
end

----------Pit Jump---------
local function Warp09(line, mobj)	
WW_InstructionAll("JUMP!")
	for player in players.iterate do
		if player.spectator then continue end
		player.kartstuff[k_itemtype] = KITEM_SNEAKER
		player.kartstuff[k_itemamount] = 1
	end
end

----------Reach sky---------
local function Warp10(line, mobj)	
WW_InstructionAll("To the sky!")
	for player in players.iterate do
		if player.spectator then continue end
		player.kartstuff[k_itemtype] = KITEM_POGOSPRING
		player.kartstuff[k_itemamount] = 8
	end
end

----------Change color---------
local function Warp11(line, mobj)	
	//Check current color of players
	//check after 4s if player has new Color
	//if yes => win else NOPE you die
end

----------Learn to type---------
local function Warp12(line, mobj)	
	//choose a random word from a pull
	//check after 4s if player has writting this word
	//if yes => win else NOPE you die
end

----------Survive 1---------
local function Warp13(line, mobj)	

end

----------Survive 2---------
local function Warp14(line, mobj)	

end

----------DON'T SURVIVE---------
local function Warp15(line, mobj)	
WW_InstructionAll("Fall in the pit!")
end

----------Water Slide---------
local function Warp16(line, mobj)	
WW_InstructionAll("RACE!")
end

----------Sink rain---------
local function Warp17(line, mobj)	
	for player in players.iterate do
		if player.spectator then continue end
		player.kartstuff[k_itemtype] = KITEM_ORBINAUT
		player.kartstuff[k_itemamount] = 1
	end
end

----------Hexagone---------
local function Warp18(line, mobj)	
WW_InstructionAll("HEXAGONE")
end

----------------------------------------
----------team stuff--------------------
----------------------------------------

----------2 team  - Orbi battle---------
local function Warp19(line, mobj)	
	for player in players.iterate do
		if player.spectator then continue end
		player.kartstuff[k_itemtype] = KITEM_ORBINAUT
		player.kartstuff[k_itemamount] = 1
	end
	// team with most point win
end

----------2 team  - SOCCER---------
local function Warp20(line, mobj)	
	// Team win when ball go to the oposing goal
end

----------2 team  - Mine---------
local function Warp21(line, mobj)	
for player in players.iterate do
		if player.spectator then continue end
		player.kartstuff[k_itemtype] = KITEM_MINE
		player.kartstuff[k_itemamount] = 1
	end
end


----------2 color no team  - catch---------
local function Warp22(line, mobj)	
	// Red player win if it touch a blue players
	// blue player win if no red touch him , victory is not based on team
end

----------Kamikase---------
local function Warp23(line, mobj)	
	// set eggman bomb timer to One player, this player must hit someone to win
	// other player must not get hit to win
end

----------Dodge Giant---------
local function Warp24(line, mobj)	
	// One player get giant, he win if he touch a 1/5 of the room
	// other player win if not crushed
end

--------------------------------
----------------BOSS------------
--------------------------------

----------Boss _ Basket ---------
local function Warp25(line, mobj)	
	print("Dunk orbi to the goal! multi point")
	for player in players.iterate do
		if player.spectator then continue end
		player.kartstuff[k_itemtype] = KITEM_ORBINAUT
		player.kartstuff[k_itemamount] = 1
	end
end

----------Boss _ Hell race---------
local function Warp26(line, mobj)	
WW_InstructionAll("FINALE RACE!")
end

----------Boss _ Battle oyal---------
local function Warp27(line, mobj)	

end




-----------------------------------------
--------------------Help me---------------
-----------------------------------------



addHook("LinedefExecute", Warp00, "WWARP00")
addHook("LinedefExecute", Warp01, "WWARP01") 
addHook("LinedefExecute", Warp02, "WWARP02")
addHook("LinedefExecute", Warp03, "WWARP03")
addHook("LinedefExecute", Warp04, "WWARP04")
addHook("LinedefExecute", Warp05, "WWARP05")
addHook("LinedefExecute", Warp06, "WWARP06")
addHook("LinedefExecute", Warp07, "WWARP07")
addHook("LinedefExecute", Warp08, "WWARP08")
addHook("LinedefExecute", Warp09, "WWARP09")
addHook("LinedefExecute", Warp10, "WWARP10")
addHook("LinedefExecute", Warp11, "WWARP11")
addHook("LinedefExecute", Warp12, "WWARP12")
addHook("LinedefExecute", Warp13, "WWARP13")
addHook("LinedefExecute", Warp14, "WWARP14")
addHook("LinedefExecute", Warp15, "WWARP15")
addHook("LinedefExecute", Warp16, "WWARP16")
addHook("LinedefExecute", Warp17, "WWARP17")
addHook("LinedefExecute", Warp18, "WWARP18")
addHook("LinedefExecute", Warp19, "WWARP19")
addHook("LinedefExecute", Warp20, "WWARP20")
addHook("LinedefExecute", Warp21, "WWARP21")
addHook("LinedefExecute", Warp22, "WWARP22")
addHook("LinedefExecute", Warp23, "WWARP23")
addHook("LinedefExecute", Warp24, "WWARP24")
addHook("LinedefExecute", Warp25, "WWARP25")
addHook("LinedefExecute", Warp26, "WWARP26")
addHook("LinedefExecute", Warp27, "WWARP27")