-- Small convinience function to register warioware linedef actions as global
-- functions and linedef executors at same time

--local WW_DEBUG = true

rawset(_G, "WW_Event", function(name, func)
	rawset(_G, name, func)
	addHook("LinedefExecute", func, name)
	
	if WW_DEBUG then
		COM_AddCommand(name:lower(), func)
	end
end)

-- Just a reminder
if WW_DEBUG then
	addHook("ThinkFrame", function()
		if leveltime == 1 then
			COM_BufInsertText(server, "csay \"WARIO WARE DEBUG IS ACTIVE DON'T FORGET TO REMOVE IT\"")
		end
	end)
end